#include <SoftwareSerial.h>
#include <DFRobotDFPlayerMini.h>
#include <Arduino.h>
#include <BluetoothSerial.h>
#include <ESP32Servo.h>



BluetoothSerial SerialBT;

Servo lenkungServo;

#define RX 3                      // RX pin DFPlayer
#define TX 1                      // TX pin DFPlayer
#define PIN_TRIGGER 0             // Ultraschallsensor Trigger Pin
#define PIN_ECHO 4                // Ultraschallsensor Echo Pin
#define ENGFOR 33                 // Motor Pin bei High forwärts
#define ENGBACK 32                // Motor Pin bei High rückwärts
#define ENGSTOP 26                // Notbremse soll forwärts blockieren
#define LENK 14                   // PWM-Eingang vom Servomotor




unsigned long duration1 = millis();//für die Programm dauerberechnung
unsigned long duration2 = millis();//für die Programm dauerberechnung
unsigned long durationSound = millis();//Timer für die Soundübertragung
volatile int soundNew = 0;        //wird zur Kontrolle ob sich der wertgeändert hat benötigt
int trighigh = 4000;              //Notbrems Assistens Maximalwert bis Trigger
int triglow = 15;                 //Notbrems Assistens Minimalwert bis Trigger
unsigned int distance = 0;        // der Abstand den der Ultraschall mist in cm
unsigned long duration = 0;       //Dauer die das signal braucht um wieder beim Ultraschall anzukommen
String empfangen = "";            //empfangende Botschaften der app als string
int lenkung = 0;                  //der Gewünchte Lenkeinschlag von 0 - 100
int richtung = 0;                 //0 = stillstand 1 = forwärts 2 = rückwärts
String hilfMo = "";               //hilfsstring für die Richtung
String hilfLe = "";               //hilfsstring für die Lenkung
unsigned long deadcount = 0;      //hilfsvariable für den Sound
int emBreak = 0;                  //hilfsvariable für Notbremsassistent

HardwareSerial mySoftwareSerial(1);
DFRobotDFPlayerMini MP3Player;

void setup() {
  //Kommunikationen starten
  mySoftwareSerial.begin(9600, SERIAL_8N1, RX, TX);
  SerialBT.begin("T1 Recep, Maik, Dominik");
  Serial.begin(115200);

  //Den Servo für den ESP32 bereit machen
  lenkungServo.setPeriodHertz(50);
  lenkungServo.attach(LENK, 500, 2500);

  //Die beiden Pins für die Antriebsteuerung setzen
  pinMode(ENGFOR, OUTPUT);
  pinMode(ENGBACK, OUTPUT);
  pinMode(ENGSTOP, OUTPUT);
  pinMode(PIN_TRIGGER, OUTPUT);
  pinMode(PIN_ECHO, INPUT);

  //Das Soundmodul einstellen. Alle Werte sind hier die Standarteinstellungen außer enableLoop
  MP3Player.setTimeOut(5);
  MP3Player.volume(30);
  MP3Player.EQ(DFPLAYER_EQ_NORMAL);
  MP3Player.outputDevice(DFPLAYER_DEVICE_SD);
  MP3Player.enableLoop();




}






void loop()
{
  //Wenn an der BT Connection Daten anliegen
  if (SerialBT.available()) {
    duration1 = millis();
    // den String leeren
    String empfangen = "";
    //Die ankommenden Daten einlesen, bis alles da ist
    while (SerialBT.available())
    {
      empfangen += (char)SerialBT.read();                               //Daten Einlesen die Zahlen werden mit einer char konvertierung empfangen
      delay(2 );                         
    }
    //fehler aus dem String löschen
    richtung = empfangen.indexOf("@") + 1;                              //empfangen wird ["@", Zahl für Richtung, ";", 3 Zahlen für Lenkwinkel, ";", Zahlfür Motorsound]
    empfangen = empfangen.substring(richtung, richtung + 8);            //sucht nach dem ersten @ und nimmt dann die nächsten 8 Ziffern damit der ESP32 weiß wo der Anfang der Nachricht ist
    
    //Der erste Char gibt auskunft über die Richtung des Motors
    String hilfMo = (String) empfangen.charAt(0);
    richtung = hilfMo.toInt();
    /*
       0 = Still
       1 = Vorwärts
       2 = Rückwärts
    */
    //Entsprechend der Definition der Daten die Pins schalten
    //Der L298N ist eine Doppel H-Brücke, er kann somit also auch die Spannung drehen (vorwärts / rückwärts). Daher sind 2 Pins zum Schalten notwendig.

    if ((richtung == 0) & (emBreak == 0))
    {
      digitalWrite(ENGFOR, LOW);
      digitalWrite(ENGBACK, LOW);
    }
    else if ((richtung == 1) & (emBreak == 0))
    {
      digitalWrite(ENGFOR, HIGH);
      digitalWrite(ENGBACK, LOW);
    }
    else if ((richtung == 2) & (emBreak == 0))
    {
      digitalWrite(ENGFOR, LOW);
      digitalWrite(ENGBACK, HIGH);
    }


    if ((richtung == 0) & (emBreak == 1))
    {
      digitalWrite(ENGFOR, LOW);
      digitalWrite(ENGBACK, LOW);
    }
    else if ((richtung == 1) & (emBreak == 1))
    {
      digitalWrite(ENGFOR, LOW);
      digitalWrite(ENGBACK, LOW);
    }
    else if ((richtung == 2) & (emBreak == 1))
    {
      digitalWrite(ENGFOR, LOW);
      digitalWrite(ENGBACK, HIGH);
    }
    //Die der 3 - 5 Char gibt über die Lenkung auskunft
    String hilfLe = (String) empfangen.substring(2, 5);
    lenkung = hilfLe.toInt();

    //Entsprechend der Definition der Daten die den Servo setzen
    if (lenkung == 50)
    {
      lenkungServo.write(85);
    }
    else if ((lenkung > 50) && (lenkung < 100))
    {
      lenkungServo.write((map(lenkung, 51, 100, 84, 50)));      //Nutzen der Map Funktion zum Interpolieren der Lenkwinkel
    }
    else if ((lenkung < 50) && (lenkung > 0))
    {
      lenkungServo.write((map(lenkung, 0, 49, 95, 86)));
    }
    // der letzte Char gibt auskunft ob mit oder ohne Motorsound
    empfangen.remove(0, 6);
    soundNew = empfangen.toInt();

    duration2 = millis();
    duration2 = duration2 - durationSound;                      //der DFPlayer hat eine baudrate von 9600 daher dauert eine Übertragung 100ms
    if((soundNew == 4) & (duration2 >= 100)){                   
      MP3Player.pause();
      durationSound = millis();
    }
    if((soundNew == 5) & (duration2 >= 100)){
      MP3Player.start();
      durationSound = millis();
    }

    //Überwachung des Ultraschallsensors
    digitalWrite(PIN_TRIGGER, LOW);
    delayMicroseconds(2);
    digitalWrite(PIN_TRIGGER, HIGH);
    delayMicroseconds(10);
    digitalWrite(PIN_TRIGGER, LOW);

    unsigned long duration = pulseIn(PIN_ECHO, HIGH);
    unsigned int distance = duration / 58;

    
    //abgleich ob man sich noch im Rahmen bewegt
    if ((distance <= triglow) || (distance >= trighigh)) {    //triggerhigh nur verwenden wenn man den Ultraschallsensor anwinkelt wenn man zum Beispiel Tischkanten erkennen möchte.
      digitalWrite(ENGFOR, LOW);
      emBreak = 1;
    }
    else {
      emBreak = 0;
    }
    delay(0);
    deadcount = 0;
  }
  else if (deadcount == 1500) {                               //deadcount soll dafür sorgen das wenn die App geschlossen ist, der ESP32 nach 1,5 Sekunden alles Auschaltet
    MP3Player.pause();
  }
  else {
    deadcount ++;
    delay(1);
  }
  duration2 = millis();                                       //verschiedene Serial.prints zur Fehleranalyse
  duration2 = duration2 - duration1;
  Serial.println ("Vorwärts/Rückwärts :");
  Serial.println (richtung);
  Serial.println ("Lenkung :");
  Serial.println (lenkung);
  Serial.println ("Sound :");
  Serial.println (soundNew);
  Serial.println ("dauer :");
  Serial.println (duration2);
}
